Denis Vlasenko | ab9eef2 | 2007-03-07 22:02:23 +0000 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | |
Ron Yorston | ecaec1d | 2018-02-09 09:01:19 +0000 | [diff] [blame] | 3 | test -f "$bindir/.config" && . "$bindir/.config" |
| 4 | |
Denys Vlasenko | c0e37b4 | 2011-10-31 01:08:35 +0100 | [diff] [blame] | 5 | FAILCOUNT=0 |
Dan Fandrich | 140ac91 | 2010-08-29 04:47:03 +0200 | [diff] [blame] | 6 | |
Denys Vlasenko | c0e37b4 | 2011-10-31 01:08:35 +0100 | [diff] [blame] | 7 | bb="busybox " |
Denis Vlasenko | ab9eef2 | 2007-03-07 22:02:23 +0000 | [diff] [blame] | 8 | |
Denys Vlasenko | c0e37b4 | 2011-10-31 01:08:35 +0100 | [diff] [blame] | 9 | unset LC_ALL |
| 10 | unset LC_MESSAGES |
| 11 | unset LANG |
| 12 | unset LANGUAGE |
Denis Vlasenko | ab9eef2 | 2007-03-07 22:02:23 +0000 | [diff] [blame] | 13 | |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 14 | hello_Z() { |
| 15 | # Compressed "HELLO\n" |
| 16 | $ECHO -ne "\x1f\x9d\x90\x48\x8a\x30\x61\xf2\x44\x01" |
| 17 | } |
| 18 | |
Denys Vlasenko | c0e37b4 | 2011-10-31 01:08:35 +0100 | [diff] [blame] | 19 | hello_gz() { |
| 20 | # Gzipped "HELLO\n" |
| 21 | #_________________________ vvv vvv vvv vvv - mtime |
| 22 | $ECHO -ne "\x1f\x8b\x08\x00\x85\x1d\xef\x45\x02\x03\xf3\x70\xf5\xf1\xf1\xe7" |
| 23 | $ECHO -ne "\x02\x00\x6e\xd7\xac\xfd\x06\x00\x00\x00" |
| 24 | } |
| 25 | |
| 26 | hello_bz2() { |
| 27 | # Bzipped "HELLO\n" |
| 28 | $ECHO -ne "\x42\x5a\x68\x39\x31\x41\x59\x26\x53\x59\x5b\xb8\xe8\xa3\x00\x00" |
| 29 | $ECHO -ne "\x01\x44\x00\x00\x10\x02\x44\xa0\x00\x30\xcd\x00\xc3\x46\x29\x97" |
| 30 | $ECHO -ne "\x17\x72\x45\x38\x50\x90\x5b\xb8\xe8\xa3" |
| 31 | } |
| 32 | |
Denys Vlasenko | 69c8c69 | 2015-10-11 16:27:55 +0200 | [diff] [blame] | 33 | for ext in \ |
Denys Vlasenko | 57aeb62 | 2015-10-12 03:15:36 +0200 | [diff] [blame] | 34 | `test x"$CONFIG_GUNZIP" = x"y" && echo gz` \ |
| 35 | `test x"$CONFIG_BUNZIP2" = x"y" && echo bz2` \ |
Denys Vlasenko | 69c8c69 | 2015-10-11 16:27:55 +0200 | [diff] [blame] | 36 | `test x"$CONFIG_UNCOMPRESS" = x"y" && echo Z` |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 37 | do |
| 38 | prep() { |
| 39 | rm -f t1.$ext t2.$ext t_actual |
| 40 | hello_$ext >t1.$ext |
| 41 | hello_$ext >t2.$ext |
| 42 | } |
Denys Vlasenko | c0e37b4 | 2011-10-31 01:08:35 +0100 | [diff] [blame] | 43 | |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 44 | check() { |
| 45 | eval $2 >t_actual 2>&1 |
| 46 | if $ECHO -ne "$expected" | cmp - t_actual; then |
| 47 | echo "PASS: $1" |
| 48 | else |
| 49 | echo "FAIL: $1" |
| 50 | FAILCOUNT=$((FAILCOUNT + 1)) |
| 51 | fi |
| 52 | } |
Denys Vlasenko | c0e37b4 | 2011-10-31 01:08:35 +0100 | [diff] [blame] | 53 | |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 54 | mkdir testdir 2>/dev/null |
| 55 | ( |
| 56 | cd testdir || { echo "cannot cd testdir!"; exit 1; } |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 57 | expected="HELLO\nok\n" |
Denys Vlasenko | 69c8c69 | 2015-10-11 16:27:55 +0200 | [diff] [blame] | 58 | prep |
| 59 | check "zcat: dont delete $ext src" "${bb}zcat t2.$ext; test -f t2.$ext && echo ok" |
| 60 | exit $FAILCOUNT |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 61 | ) |
Denys Vlasenko | 69c8c69 | 2015-10-11 16:27:55 +0200 | [diff] [blame] | 62 | FAILCOUNT=$? |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 63 | rm -rf testdir |
| 64 | done |
Denys Vlasenko | bcdae63 | 2011-10-31 01:10:47 +0100 | [diff] [blame] | 65 | |
| 66 | |
| 67 | # Copyright 2011 by Denys Vlasenko |
| 68 | # Licensed under GPLv2, see file LICENSE in this source tree. |
| 69 | |
| 70 | . ./testing.sh |
| 71 | |
| 72 | # testing "test name" "command" "expected result" "file input" "stdin" |
| 73 | |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 74 | ## bzip algorithm |
| 75 | |
Denys Vlasenko | bcdae63 | 2011-10-31 01:10:47 +0100 | [diff] [blame] | 76 | # "input" file is bzipped file with "a\n" data |
| 77 | testing "bzcat can print many files" \ |
Ron Yorston | ecaec1d | 2018-02-09 09:01:19 +0000 | [diff] [blame] | 78 | "bzcat input input; echo \$?" \ |
Denys Vlasenko | bcdae63 | 2011-10-31 01:10:47 +0100 | [diff] [blame] | 79 | "\ |
| 80 | a |
| 81 | a |
| 82 | 0 |
| 83 | " "\ |
| 84 | \x42\x5a\x68\x39\x31\x41\x59\x26\x53\x59\x63\x3e\xd6\xe2\x00\x00\ |
| 85 | \x00\xc1\x00\x00\x10\x20\x00\x20\x00\x21\x00\x82\xb1\x77\x24\x53\ |
| 86 | \x85\x09\x06\x33\xed\x6e\x20\ |
| 87 | " "" |
| 88 | |
| 89 | # "input" file is bzipped zero byte file |
| 90 | testing "bzcat can handle compressed zero-length bzip2 files" \ |
Ron Yorston | ecaec1d | 2018-02-09 09:01:19 +0000 | [diff] [blame] | 91 | "bzcat input input; echo \$?" \ |
Denys Vlasenko | bcdae63 | 2011-10-31 01:10:47 +0100 | [diff] [blame] | 92 | "0\n" \ |
| 93 | "\x42\x5a\x68\x39\x17\x72\x45\x38\x50\x90\x00\x00\x00\x00" "" |
| 94 | |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 95 | ## compress algorithm |
| 96 | |
| 97 | # "input" file is compressed (.Z) file with "a\n" data |
Denys Vlasenko | 69c8c69 | 2015-10-11 16:27:55 +0200 | [diff] [blame] | 98 | test x"$CONFIG_UNCOMPRESS" = x"y" && \ |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 99 | testing "zcat can print many files" \ |
Ron Yorston | ecaec1d | 2018-02-09 09:01:19 +0000 | [diff] [blame] | 100 | "zcat input input; echo \$?" \ |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 101 | "\ |
| 102 | a |
| 103 | a |
| 104 | 0 |
| 105 | " "\ |
| 106 | \x1f\x9d\x90\x61\x14\x00\ |
| 107 | " "" |
| 108 | |
| 109 | # "input" file is compressed (.Z) zero byte file |
Denys Vlasenko | 69c8c69 | 2015-10-11 16:27:55 +0200 | [diff] [blame] | 110 | test x"$CONFIG_UNCOMPRESS" = x"y" && \ |
| 111 | testing "zcat can handle compressed zero-length (.Z) files" \ |
Ron Yorston | ecaec1d | 2018-02-09 09:01:19 +0000 | [diff] [blame] | 112 | "zcat input input; echo \$?" \ |
Thiago Jung Bauermann | 17b1622 | 2015-05-11 17:18:59 +0200 | [diff] [blame] | 113 | "0\n" \ |
| 114 | "\x1f\x9d\x90\x00" "" |
| 115 | |
Denys Vlasenko | bcdae63 | 2011-10-31 01:10:47 +0100 | [diff] [blame] | 116 | |
| 117 | |
Denys Vlasenko | c0e37b4 | 2011-10-31 01:08:35 +0100 | [diff] [blame] | 118 | exit $((FAILCOUNT <= 255 ? FAILCOUNT : 255)) |